# Contribution Guidelines for OpenFPM (openfpm_pdata)

We appreciate your interest in contributing to the `OpenFPM` project! Before starting, please take a moment to read these guidelines. Following these will help us streamline the collaboration process and maintain the project effectively.

## General Guidelines

1. **Code of Conduct**: Please follow our Code of Conduct in all your interactions within the project.

2. **Issues**: If you find a bug or have a feature request, please check the existing issues first. If it hasn't been reported or requested, feel free to create a new one.

3. **Pull Requests**: We follow the "fork-and-pull" workflow. Please create a separate branch in your fork for each feature or fix, instead of using your `master` branch. This way, you can submit a pull request (PR) for each feature or fix, which makes the review process simpler.

## Contributing to Submodules

The `openfpm_pdata` project includes several submodules, like `openfpm_numerics` and others. If you want to contribute to these, please follow the guidelines below:

1. **Submodule Branch**: Create a new branch for each feature or fix in the respective submodule. Use the following pattern for your branch names: `fix/issue-short-description` or `feat/feat-short-description`.

2. **Pull Requests for Submodules**: If you're submitting a PR for a submodule, make sure to initiate the PR to the submodule's repository and not to the main `openfpm_pdata` repository. This helps keep the project's version control history clean and easy to follow.

3. **Linking PRs**: If your PR for a submodule is related to an issue in the main `openfpm_pdata` repository, please include a link to that issue in the PR description. This will help us understand the context of the changes you've made.

## Pull Request Process

1. **Update README**: If your changes involve adding or modifying functionality, ensure the README.md file is updated accordingly.

2. **Code Documentation**: Please document and comment your code. It helps others understand the purpose of your code and makes maintenance easier.

3. **Testing**: Make sure your changes pass all existing tests before submitting a PR. If you add new functionality, please also add appropriate tests.

4. **Code Review**: After submitting a PR, one of the project maintainers will review it. They may suggest some changes or improvements. Please don't be disheartened if this happens; it's a standard part of the process.

Thank you for your interest in contributing to `OpenFPM`! We look forward to working with you and building a better project together.

---
